#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<stack>
using namespace std;

const int MAX_N = 50010;

int n, m, u, v;
long long ans;

int currbeg, currend;

struct ss
{
    int to;
    int num;

    bool operator < (ss A) const
    {
        return num < A.num;
    }

};

struct edg
{
    int u, v;
};

vector<ss> sys[MAX_N];
vector<edg> edges;

int par[MAX_N];

int root(int curr)
{
    if(par[curr] == curr){return curr;}
    par[curr] = root(par[curr]);
    return par[curr];
}

int build_graph()
{
    for(int i = 0; i <= n; i++){
        par[i] = i;
    }
    int comp = n;
    int i;

    for(i = currbeg; comp > 1 && i < m; i++){
        int u = edges[i].u;
        int v = edges[i].v;
        if(root(u) != root(v)){
            par[par[u]] = root(v);
            comp--;
            if(comp == 1){
                //cout << "ll" << i << endl;
            }
        }
    }

    if(comp > 1){
        return -1;
    }

    return i-1;

}

priority_queue<ss> dijkstra;
int pathTo[MAX_N];
bool isDisconnected[MAX_N];

int dijk()
{
    for(int i = 0; i <= n; i++){
        pathTo[i] = 999999;
    }

    dijkstra.push({0, 999998});

    stack<int> st;

    int minedge;
    while(!dijkstra.empty()){
        ss c = dijkstra.top();
        dijkstra.pop();
        if(pathTo[c.to] == 999999){
            pathTo[c.to] = c.num;
            st.push(c.to);
            //cout << c.to << " " << c.num << endl;
            minedge = c.num;
            for(int i = 0; i < sys[c.to].size() && sys[c.to][i].num <= currend; i++){
                if(sys[c.to][i].num >= currbeg && pathTo[sys[c.to][i].to] == 999999){
                    dijkstra.push({sys[c.to][i].to, min(c.num, sys[c.to][i].num)});
                }
            }
        }
    }

    memset(isDisconnected, 0, MAX_N);

    while(!st.empty() && pathTo[st.top()] == minedge){
        isDisconnected[st.top()] = true;
        st.pop();
    }


    return minedge;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;

    for(int i = 0; i < m; i++){
        cin >> u >> v;
        u--;
        v--;
        edges.push_back({u, v});
        sys[u].push_back({v, i});
        sys[v].push_back({u, i});
    }

    /*
    for(int i = m-1; i >= 0; i++){
        sys[edges[i].u].push_back({edges[i].v, i});
    }*/

    currbeg = 0;
    currend = build_graph();

    while(true){
        //cout << currend << " " << next << endl;
        if(currend >= m){
            break;
        }
        int next = dijk();
        ans += ((long long)m - (long long)currend)*(long long)(next-currbeg+1);
        currbeg = next+1;
        while(m > currend){
            if((isDisconnected[edges[currend].u] && !isDisconnected[edges[currend].v]) || (!isDisconnected[edges[currend].u] && isDisconnected[edges[currend].v])){
                break;
            }
            currend++;
        }
        //currbeg++;
    }

    cout << ans << endl;

return 0;
}
/*
4 4
1 2
2 4
1 3
1 4

6 9
1 2
1 3
1 4
4 5
2 5
2 3
3 5
5 6
2 6
*/
