#include <iostream>
#include <vector>
#include <cstring>
#include <stack>

const int MAXN = 5e4 + 10;

int n, m;

struct edge {
    int to, num;
};

std::vector<edge> adj[MAXN];
std::stack<int> k;
bool used[MAXN];

bool dfs(int b, int e)
{
    std::memset(used, 0, sizeof(used));

    used[1] = true;
    k.push(1);

    while(!k.empty())
    {
        int curr = k.top();
        k.pop();

        for(int i = 0; i < adj[curr].size(); ++ i)
        {
            edge next = adj[curr][i];
            if(next.num >= b && next.num <= e && !used[next.to])
            {
                used[next.to] = true;
                k.push(next.to);
            }
        }
    }

    bool ans = 1;

    for(int i = 1; i <= n; ++ i)
    {
        ans &= used[i];
    }

    return ans;
}

int main()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    std::cin >> n >> m;

    int l = 1, r = 1;

    for(int i = 0; i < m; ++ i)
    {
        int u, v;
        std::cin >> u >> v;
        adj[u].push_back({v, i + 1});
        adj[v].push_back({u, i + 1});
    }

    for(; r <= m; ++ r)
    {
        if(dfs(1, i))
        {
            break;
        }
    }

    std::cout << r << '\n';

    return 0;
}
