#include <iostream>
#include <utility>
#include <cstdio>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

bool used[MAXN + 5];
vector<int> G[MAXN + 5];

bool DFS(int u, int turn)
{
    used[u] = true;
    bool t;
    if (turn == 1) t = true;
    else t = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (turn == 1) t = (t & DFS(G[u][i], (turn + 1) % 2));
            else t = (t | DFS(G[u][i], (turn + 1) % 2));
            if (turn == 1 and t == false) break;
            if (turn == 0 and t == true) break;
        }
    }
    used[u] = false;
    return t;
}

int d[MAXN + 5];
bool usedBFS[MAXN + 5];

void BFS(int u)
{
    usedBFS[u] = true;
    d[u] = 0;
    queue<int> q;
    q.push(u);
    while (!q.empty())
    {
        u = q.front();
        q.pop();

        for (int i = 0; i < G[u].size(); ++ i)
        {
            if (!usedBFS[G[u][i]])
            {
                usedBFS[G[u][i]] = true;
                d[G[u][i]] = d[u] + 1;
                q.push(G[u][i]);
            }
        }
    }
}

int main()
{
    int N, M;
    scanf("%d%d", &N, &M);

    int u, v;
    for (int i = 0; i < M; ++ i)
    {
        scanf("%d%d", &u, &v);
        G[u].push_back(v);
        G[v].push_back(u);
    }

    BFS(1);
    int t = (int) DFS(1, 1);

    cout << t;
    for (int i = 2; i <= N; ++ i)
        printf("%d", (t + d[i] + 1) % 2);
    printf("\n");

    return 0;
}
