#include <iostream>
#include <utility>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 50000;

int cnt, i0, j0;
vector<bool> used(MAXN + 5, 0), clearv(MAXN + 5, 0);
vector< pair<int, int> > G[MAXN + 5];

void BFS(int u)
{
    used[u] = true;
    queue<int> q;
    q.push(u);
    cnt++;
    while (!q.empty())
    {
        u = q.front();
        q.pop();

        for (int i = 0; i < G[u].size(); ++ i)
        {
            if (i0 <= G[u][i].second and G[u][i].second <= j0)
            {
                if (!used[G[u][i].first])
                {
                    cnt++;
                    used[G[u][i].first] = true;
                    q.push(G[u][i].first);
                }
            }
        }
    }
}


int main()
{
    int n, m;
    scanf("%d%d", &n, &m);

    int u, v;
    for (int i = 0; i < m; ++ i)
    {
        scanf("%d%d", &u, &v);
        G[u].push_back(make_pair(v, i));
        G[v].push_back(make_pair(u, i));
    }

    int ans = 0;
    for (int i = 0; i < m; ++ i)
    {
        for (int j = i + n - 2; j < m; ++ j)
        {
            cnt = 0;
            i0 = i; j0 = j;
            used = clearv;

            BFS(1);

            if (cnt == n) ans++;
        }
    }

    printf("%d\n", ans);

    return 0;
}
