#include <iostream>
#include <utility>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 50000;

int cnt, i0, j0;
vector< pair<int, int> > e;
vector<bool> used(MAXN + 5, 0), clearv(MAXN + 5, 0);
vector< pair<int, int> > G[MAXN + 5];

void BFS(int u)
{
    used[u] = true;
    cnt++;
    queue<int> q;
    q.push(u);
    while (!q.empty())
    {
        u = q.front();
        q.pop();

        for (int i = 0; i < G[u].size(); ++ i)
        {
            if (i0 <= G[u][i].second and G[u][i].second <= j0)
            {
                if (!used[G[u][i].first])
                {
                    cnt++;
                    used[G[u][i].first] = true;
                    q.push(G[u][i].first);
                }
            }
        }
    }
}

int main()
{
    int n, m;
    scanf("%d%d", &n, &m);

    int u, v;
    for (int i = 0; i < m; ++ i)
    {
        scanf("%d%d", &u, &v);
        e.push_back(make_pair(u, v));
        G[u].push_back(make_pair(v, i));
        G[v].push_back(make_pair(u, i));
    }

    int minx = m, maxx = -1;

    for (int i = 0; i < m; ++ i)
    {
        cnt = 0;
        i0 = i + 1;
        j0 = m - 1;
        used = clearv;
        BFS(e[i].first);
        if (cnt != n)
        {
            minx = i;
            break;
        }
    }

    for (int i = m - 1; i >= 0; -- i)
    {
        cnt = 0;
        i0 = 0;
        j0 = i - 1;
        used = clearv;
        BFS(e[i].first);
        if (cnt != n)
        {
            maxx = i;
            break;
        }
    }

    cout << (minx + 1) * (m - maxx) - 1 << endl;

    return 0;
}
