#include <algorithm>
#include <iostream>
#include <utility>
#include <cstdio>
#include <vector>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int path[MAXN + 5];
bool win[MAXN + 5];
int deg[MAXN + 5];
bool used[MAXN + 5];
vector<int> G[MAXN + 5];
vector< pair<int, int> > G1[MAXN + 5];

bool DFS(int u, int turn)
{
    used[u] = true;
    bool t;
    if (turn == 1) t = true;
    else t = false;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (turn == 1) t = (t & DFS(G[u][i], (turn + 1) % 2));
            else t = (t | DFS(G[u][i], (turn + 1) % 2));
            if (turn == 1 and t == false) break;
            if (turn == 0 and t == true) break;
        }
    }
    used[u] = false;
    return t;
}

int main()
{
    time_t x = clock();

    int N, M;
    scanf("%d%d", &N, &M);

    bool t = true;
    int cnt = 0;
    int u, v;
    for (int i = 0; i < M; ++ i)
    {
        scanf("%d%d", &u, &v);
        G[u].push_back(v);
        G[v].push_back(u);
        deg[u]++;
        deg[v]++;
        if (deg[u] > 2 or deg[v] > 2) t = false;
        if (deg[u] == 1) cnt++;
        else cnt--;
        if (deg[v] == 1) cnt++;
        else cnt--;
    }

    if (t)
    {
        if (cnt == 0)
        {
            if (N % 2 == 0)
            {
                for (int i = 0; i < N; ++ i)
                    printf("0");
                printf("\n");
            }
            else
            {
                for (int i = 0; i < N; ++ i)
                    printf("1");
                printf("\n");
            }
        }
        else
        {
            for (int i = 1; i <= N; ++ i)
            {
                if (G[i].size() == 1)
                {
                    int k = 0;
                    path[k++] = i;
                    int j = G[i][0];
                    do
                    {
                        path[k++] = j;
                        if (G[j][0] == path[k - 2]) j = G[j][1];
                        else j = G[j][0];
                    }while (G[j].size() != 1);
                    path[k++] = j;
                    break;
                }
            }

            for (int i = 1; i <= N; ++ i)
            {
                if ((i - 1) % 2 == 0 and (N - i) % 2 == 0) win[path[i - 1]] = true;
            }

            for (int i = 1; i <= N; ++ i)
                printf("%d", win[i]);
            printf("\n");
        }
        return 0;
    }

    for (int i = 1; i <= N; ++ i)
    {
        if (clock() - x >= 0.5 * CLOCKS_PER_SEC)
        {
            for (int j = i; j <= N; ++ j)
                printf("0");
            printf("\n");
        }
        printf("%d", DFS(i, 1));
    }
    printf("\n");

    return 0;
}
