#include <iostream>
#include <cstring>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 50000;

int cnt, i0, j0;
bool used[MAXN + 5];
vector< pair<int, int> > e;
vector< pair<int, int> > G[MAXN + 5];

void BFS(int u)
{
    used[u] = true;
    queue<int> q;
    q.push(u);
    cnt++;
    while (!q.empty())
    {
        u = q.front();
        q.pop();

        for (int i = 0; i < G[u].size(); ++ i)
        {
            if (i0 <= G[u][i].second and G[u][i].second <= j0)
            {
                if (!used[G[u][i].first])
                {
                    cnt++;
                    used[G[u][i].first] = true;
                    q.push(G[u][i].first);
                }
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        e.push_back(make_pair(u, v));
        G[u].push_back(make_pair(v, i));
        G[v].push_back(make_pair(u, i));
    }

    int ans = 0;
    for (int i = 0; i < m; ++ i)
    {
        for (int j = i; j < m; ++ j)
        {
            cnt = 0;
            i0 = i; j0 = j;
            memset(used, false, sizeof(used));

            BFS(1);

            if (cnt == n) ans++;
        }
    }

    cout << ans << endl;

    return 0;
}
