#include <bits/stdc++.h>

#define MAX_N 50005
#define endl '\n'

struct edge
{
    int i, j;
};

std::vector<edge> original_graph = {edge {0, 0}};

template<std::size_t N>
auto do_search(const std::vector<edge>& graph, int a, int b, int k, std::bitset<N>& out) -> void
{
    out[k] = 1;

    for(auto i = a; i <= b; ++i) {
        auto edge = graph[i];

        if(edge.i == k && !out[edge.j]) {
            do_search(graph, a, b, edge.j, out);
        } else if(edge.j == k && !out[edge.i]) {
            do_search(graph, a, b, edge.i, out);
        }
    }
}

auto is_connected(const std::vector<edge>& graph, int n, int a, int b) -> bool
{
    std::bitset<MAX_N> reached;
    do_search(graph, a, b, 1, reached);

    for(auto i = 1; i <= n; ++i) {
        if(!reached[i]) {
            return false;
        }
    }

    return true;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    int u, v;
    for(auto i = 1; i <= m; ++i) {
        std::cin >> u >> v;
        original_graph.emplace_back(edge {u, v});
    }

    auto answer = 0;
    auto sol_i = -1;
    auto sol_j = -1;

    for(auto i = 1; i <= m; ++i) {
        for(auto j = 1; j <= m; ++j) {
            if(is_connected(original_graph, n, i, j)) {
                sol_i = i;
                sol_j = j;
                break;
            }
        }

        if(sol_i != -1) {
            answer = m - sol_j + 1;
            break;
        }
    }

    auto curr_incr = answer;
    for(auto i = sol_i + 1; i <= m; ++i) {
        auto edge = original_graph[i];
        if(edge.i == edge.j) {
            --curr_incr;
        }

        if(--curr_incr <= 0) {
            break;
        }

        answer += curr_incr;
    }

    std::cout << answer << endl;

    return 0;
}
