#include <bits/stdc++.h>

#define MAX_N 50005
#define endl '\n'

typedef unsigned long long ull;

struct edge
{
    int i, j;
};

std::vector<edge> graph = {edge {0, 0}};

template<std::size_t N>
auto do_search(int a, int b, int k, std::bitset<N>& out) -> void
{
    out[k] = 1;

    for(auto i = a; i <= b; ++i) {
        auto edge = graph[i];

        if(edge.i == k && !out[edge.j]) {
            do_search(a, b, edge.j, out);
        } else if(edge.j == k && !out[edge.i]) {
            do_search(a, b, edge.i, out);
        }
    }
}

auto is_connected(int n, int a, int b) -> bool
{
    std::bitset<MAX_N> reached;
    do_search(a, b, 1, reached);

    for(auto i = 1; i <= n; ++i) {
        if(!reached[i]) {
            return false;
        }
    }

    return true;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    int u, v;
    for(auto i = 1; i <= m; ++i) {
        std::cin >> u >> v;
        graph.emplace_back(edge {u, v});
    }

    auto answer = 0;
    for(auto i = 1; i <= m; ++i) {
        for(auto j = i + 1; j <= m; ++j) {
            if(j - i + 2 < n) {
                continue;
            }

            if(is_connected(n, i, j)) {
                answer += m - j + 1;
                break;
            }
        }
    }

    std::cout << answer << endl;

    return 0;
}
