#include <bits/stdc++.h>

#define MAX_N 50005
#define endl '\n'

typedef unsigned long long ull;

struct edge
{
    int i, j;
};

std::vector<edge> graph = {edge {0, 0}};

auto find_connected(int n, int m, int a) -> int
{
    std::cout << "looking for a connected graph with edges in range (" << a << ", ?)" << endl;

    std::bitset<MAX_N> reached;
    std::queue<int> nodes;

    int min_b = n + a - 2;
    std::cout << "min b -> " << min_b << endl;

    nodes.push(1);

    while(!nodes.empty()) {
        auto node = nodes.front();
        nodes.pop();

        reached[node] = 1;

        for(auto i = a; i <= min_b; ++i) {
            auto edge = graph[i];

            if(edge.i == node && !reached[edge.j]) {
                nodes.push(edge.j);
            } else if(edge.j == node && !reached[edge.i]) {
                nodes.push(edge.i);
            }
        }
    }

    auto needed = 0;
    for(auto i = 1; i <= n; ++i) {
        if(!reached[i]) {
            ++needed;
        }
    }

    std::cout << "unreached nodes -> " << needed << endl;

    int curr_b;
    for(curr_b = min_b + 1; curr_b <= m && needed; ++curr_b) {
        auto edge = graph[curr_b];

        if(reached[edge.i] && !reached[edge.j]) {
            reached[edge.j] = 1;
            --needed;
        }
        else if(reached[edge.j] && !reached[edge.i]) {
            reached[edge.i] = 1;
            --needed;
        }
    }

    return needed == 0 ? curr_b - 1 : -1;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    int u, v;
    for(auto i = 1; i <= m; ++i) {
        std::cin >> u >> v;
        graph.emplace_back(edge {u, v});
    }

    auto answer = 0;
    for(auto i = 1; i <= m; ++i) {
        auto j = find_connected(n, m, i);
        std::cout << j << endl;
        if(j != -1) {
            answer += m - j + 1;
        }
    }

    std::cout << answer << endl;

    return 0;
}
