#include <bits/stdc++.h>

#define MAX_N 50005
#define endl '\n'

struct edge
{
    int n, i, j;
};

std::vector<edge> original_graph;

template<std::size_t N>
auto do_search(const std::vector<edge>& graph, int k, std::bitset<N>& out) -> void
{
    out[k] = 1;

    for(auto &edge : graph) {
        if(edge.i == k && !out[edge.j]) {
            do_search(graph, edge.j, out);
        } else if(edge.j == k && !out[edge.i]) {
            do_search(graph, edge.i, out);
        }
    }
}

auto is_connected(const std::vector<edge>& graph, int n) -> bool
{
    std::bitset<MAX_N> reached;
    do_search(graph, graph[0].i, reached);

    for(auto i = 1; i <= n; ++i) {
#ifdef DEBUG
        std::cout << "node " << i << " -> " << reached[i] << endl;
#endif
        if(!reached[i]) {
            return false;
        }
    }

    return true;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    int u, v;
    for(auto i = 1; i <= m; ++i) {
        std::cin >> u >> v;
        original_graph.emplace_back(edge {i, u, v});
    }

#ifdef DEBUG
    std::cout << is_connected(original_graph, n) << endl;
#endif

    auto sol = 0;
    for(auto &val : original_graph) {
        if(val.i > m || val.j > m) {
            continue;
        }

        std::vector<edge> modified_graph(original_graph.size());

        auto last = std::copy_if(original_graph.begin(), original_graph.end(),
                                 modified_graph.begin(),
            [&](edge a) {
                return a.n >= val.i && a.n <= val.j;
            });

        modified_graph.resize(std::distance(modified_graph.begin(), last));

#ifdef DEBUG
        std::cout << "new graph: " << endl;
        for(auto &edge : modified_graph) {
            std::cout << "(" << edge.i << ","<< edge.j << ") [" << edge.n << "]" << endl;
        }
#endif

        if(is_connected(modified_graph, n)) {
#ifdef DEBUG
            std::cout << "connected." << endl;
#endif
            sol++;
        }
    }

    std::cout << sol << endl;

    return 0;
}
