#include <bits/stdc++.h>

#define MAX_N 50005
#define endl '\n'

struct edge
{
    int n, i, j;
};

std::vector<edge> original_graph;

template<std::size_t N>
auto do_search(const std::vector<edge>& graph, int a, int b, int k, std::bitset<N>& out) -> void
{
    out[k] = 1;

    for(auto i = a - 1; i < b; ++i) {
        auto edge = graph[i];

        if(edge.i == k && !out[edge.j]) {
            do_search(graph, a, b, edge.j, out);
        } else if(edge.j == k && !out[edge.i]) {
            do_search(graph, a, b, edge.i, out);
        }
    }
}

auto is_connected(const std::vector<edge>& graph, int n, int a, int b) -> bool
{
    std::bitset<MAX_N> reached;
    do_search(graph, a, b, 1, reached);

    for(auto i = 1; i <= n; ++i) {
        if(!reached[i]) {
            return false;
        }
    }

    return true;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    int u, v;
    for(auto i = 1; i <= m; ++i) {
        std::cin >> u >> v;
        original_graph.emplace_back(edge {i, u, v});
    }

    auto sol = 0;
    for(auto i = 1; i <= m; ++i) {
        for(auto j = i; j <= m; ++j) {
            if(is_connected(original_graph, n, i, j)) {
                sol++;
            }
        }
    }

    std::cout << sol << endl;

    return 0;
}
