#include <iostream>
#include <set>
using namespace std;
#define MAXN int(1e5 + 5)
#define endl '\n'
int br;
set<int> rows[MAXN], cols[MAXN];
set<pair<int, int> > points;
bool extreme(int x, int y){
	bool horizontal = false, vertical = false;
	if(x == *(cols[y].begin()) || x == *(--cols[y].end())) horizontal = true;
	if(y == *(rows[x].begin()) || y == *(--rows[x].end())) vertical = true;
	return vertical && horizontal;
}
bool inside(int x, int y){
	bool horizontal = false, vertical = false;
	if(x == *(cols[y].begin()) || x == *(--cols[y].end())) horizontal = true;
	if(y == *(rows[x].begin()) || y == *(--rows[x].end())) vertical = true;
	return !vertical && !horizontal;
}
pair<int, int> answer(){
	int ex = 0, ins = 0;
	for(pair<int, int> p : points){
		if(extreme(p.first, p.second)) ++ex;
		else if(inside(p.first, p.second)) ++ins;
	}
	return {ex, ins};
}
int main(){
	cin.tie(0); ios::sync_with_stdio(false);
	cin >> br;
	for(int i = 0; i < br; ++i){
		int x, y; cin >> x >> y;
		rows[x].insert(y);
		cols[y].insert(x);
		points.insert({x, y});
	}
	pair<int, int> res = answer();
	cout << res.first << ' ' << res.second << endl;
	int queries; cin >> queries;
	for(int i = 0; i < queries; ++i){
		int type, x, y; cin >> type >> x >> y;
		if(type == 1){
			points.insert({x, y});
			rows[x].insert(y); cols[y].insert(x);
		}
		else{
			points.erase({x, y});
			cols[y].erase(x);
			rows[x].erase(y);
		}
		pair<int, int> res = answer();
		cout << res.first << ' ' << res.second << endl;
	}
	return 0;
}