#include <iostream>
#include <set>
#include <cassert>

using namespace std;

struct Punct {
  int x, ind;
  bool operator < (const Punct &other) const {
    return x < other.x;
  }
};

int n, q, a, b, t, x2, y2;

bool am[4][4005], ex[4005], in[4005]; // 0-st, 1-dr, 2-jos, 3-sus
int x[2005], y[2005];
set <Punct> X[100005], Y[100005];

bool isExtern(int i) {
  return ((!am[0][i] | !am[1][i]) & (!am[2][i] | !am[3][i]));
}

bool isIntern(int i) {
  return (am[0][i] & am[1][i] & am[2][i] & am[3][i]);
}

int main() {
  cin >> n;
  for(int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    X[x[i]].insert({y[i], i});
    Y[y[i]].insert({x[i], i});
  }
  for(int i = 1; i <= n; i++) {
    auto it = X[x[i]].lower_bound({y[i], i});
    am[2][i] = (it != X[x[i]].begin());
    it++;
    am[3][i] = (it != X[x[i]].end());
    it = Y[y[i]].lower_bound({x[i], i});
    am[0][i] = (it != Y[y[i]].begin());
    it++;
    am[1][i] = (it != Y[y[i]].end());
  }
  for(int i = 1; i <= n; i++) {
    ex[i] = isExtern(i), in[i] = isIntern(i);
    a += ex[i];
    b += in[i];
  }
  cout << a << " " << b << "\n";
  cin >> q;
  for(; q; q--) {
    cin >> t >> x2 >> y2;
    if(t == 1) {
      int i;
      for(auto it : X[x2]) {
        i = it.ind;
        if(in[i] && ex[i])
          continue;
        if(it.x < y2)
          am[3][i] = 1;
        else
          am[2][i] = 1;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      for(auto it : Y[y2]) {
        i = it.ind;
        if(in[i] && ex[i])
          continue;
        if(it.x < x2)
          am[1][i] = 1;
        else
          am[0][i] = 1;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      n++;
      X[x2].insert({y2, n});
      Y[y2].insert({x2, n});
      auto it = X[x2].lower_bound({y2, i});
      am[2][i] = (it != X[x2].begin());
      it++;
      am[3][i] = (it != X[x2].end());
      it = Y[y2].lower_bound({x2, i});
      am[0][i] = (it != Y[y2].begin());
      it++;
      am[1][i] = (it != Y[y2].end());
      a += isExtern(i), b += isIntern(i);
      in[i] = isIntern(i);
      ex[i] = isExtern(i);
      cout << a << " " << b << "\n";
    } else {
      int i;
      auto itX = X[x2].lower_bound({y2, 0}), itY = Y[y2].lower_bound({x2, 0});
      for(auto it : X[x2]) {
        i = it.ind;
        if(in[i]&& ex[i])
          continue;
        if(it.x < y2) {
          itY++;
          if(itY == Y[y2].end())
            am[3][i] = 0, itY--;
          itY--;
        } else if(it.x > y2 && itY == Y[y2].begin())
          am[2][i] = 0;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      for(auto it : Y[y2]) {
        i = it.ind;
        if(in[i] && ex[i])
          continue;
        if(it.x < x2) {
          itX++;
          if(itX == X[x2].end())
            am[1][i] = 0;
          itX--;
        } else if(it.x > x2 && itX == X[x2].begin())
          am[0][i] = 0;
        b += isIntern(i) - in[i];
        a += isExtern(i) - ex[i];
        in[i] = isIntern(i);
        ex[i] = isExtern(i);
      }
      i = itX->ind;
      a -= ex[i], b -= in[i];
      in[i] = ex[i] = 1;
      X[x2].erase(itX);
      Y[y2].erase(itY);
      cout << a << " " << b << "\n";
    }
  }
  return 0;
}
