#include <iostream>

using namespace std;

const int M = 2e5 + 7, N = 5e4 + 7;

namespace DSU {
    int t[N], nl[N];
    int comp;

    int Rad(int nod) {
        if (t[nod] == 0)
            return nod;
        t[nod] = Rad(t[nod]);
        return t[nod];
    }

    void Union(int x, int y) {
        x = Rad(x);
        y = Rad(y);
        if (x == y)
            return;
        --comp;
        if (nl[x] < nl[y])
            swap(x, y);
        nl[x] += nl[y];
        t[y] = x;
    }

    void Reset(int n) {
        comp = n;
        for(int i = 1; i <= n; ++i)
            t[i] = 0, nl[i] = 1;
    }

}

struct Edge {
    int a, b;
};

Edge v[M];

int main()
{
    ///I just want to be safe so I'm going for only 20 on this one :(
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; ++i)
        cin >> v[i].a >> v[i].b;
    int ans(0);
    for (int i = 1; i <= m; ++i) {
        DSU::Reset(n);
        int j(i - 1);
        while (j < m && DSU::comp > 1) {
            ++j;
            DSU::Union(v[j].a, v[j].b);
        }
        if (DSU::comp == 1)
            ans += (m - j + 1);
    }
    cout << ans;
    return 0;
}
