#include <iostream>
#include <fstream>
#include <vector>
#include <cassert>

using namespace std;
ifstream in ("input.txt");

int const nmax = 200005;
struct Edge{
  int x;
  int y;
};
Edge edge[5 + nmax];
int sol[5 + nmax];
int mult[1 + nmax], sz[1 + nmax];

int jump(int a){
  if(a != mult[a])
    return jump(mult[a]);
  else
    return a;
}

struct Update{
  int id;
  int x;
  int y;
  int szx;
  int szy;
};
vector<Update> st;

void addEdge(int id){
  int x = edge[id].x, y = edge[id].y;
  x = jump(x);
  y = jump(y);
  if(x != y){
    if(sz[y] < sz[x])
      swap(x, y);

    st.push_back({id, x, y, sz[x], sz[y]});
    mult[x] = y;
    sz[y] += sz[x];
    sz[x] = 0;
  }
}

void undo(){
  Update e = st.back();
  mult[e.x] = e.x;
  mult[e.y] = e.y;
  sz[e.x] = e.szx;
  sz[e.y] = e.szy;
  st.pop_back();
}
void addinterval(int x, int y){
  for(int i = x;i <= y; i++)
    addEdge(i);
}

void keepinterval(int x, int y){
  while(0 < st.size() && !(x <= st.back().id && st.back().id <= y) )
    undo();
}

int n, m;

void divide(int i, int j, int x, int y){
  //[j + 1] - [x - 1] is already added
  if(j < i || y < x)
    return ;

  int mid = (i + j) / 2;

  /*
  cout << "Divide\n";
  cout << i << " " << j << '\n';
  cout << x << " " << y << '\n';
  cout << '\n';
  */

  if(j < x){

    addinterval(mid, j);
    sol[mid] = x - 1;
    while(sol[mid] <= m && st.size() < n - 1){
      sol[mid]++;
      addEdge(sol[mid]);
    }
    keepinterval(j + 1, x - 1);

    addinterval(mid, j);
    divide(i, mid - 1, x, sol[mid]);

    keepinterval(j + 1, x - 1);
    addinterval(x, sol[mid] - 1);

    divide(mid + 1, j, sol[mid], y);
    keepinterval(j + 1, x - 1);
  } else {
    sol[mid] = mid - 1;
    while(sol[mid] <= m && st.size() < n - 1){
      sol[mid]++;
      addEdge(sol[mid]);
    }

    keepinterval(0, -1);
    addinterval(mid, x - 1);

    divide(i, mid - 1, x, sol[mid]);
    keepinterval(0, -1);

    addinterval(j + 1, sol[mid] - 1);
    divide(mid + 1, j, sol[mid], y);

    keepinterval(0, -1);
  }
}

void brut(){
  for(int i = 1;i <= m; i++){
    keepinterval(0, -1);
    assert(0 == st.size());

    sol[i] = i - 1;
    while(sol[i] <= m && st.size() < (n - 1)){
      sol[i]++;
      addEdge(sol[i]);
    }
  }
}

int main()
{
  cin >> n >> m;
  for(int i = 1;i <= n; i++) {
    mult[i] = i;
    sz[i] = 1;
  }

  for(int i = 1;i <= m; i++)
    cin >> edge[i].x >> edge[i].y;

  divide(1, m, 1, m + 1);

  //brut();
  int result = 0;
  for(int i = 1;i <= m; i++)
    if(sol[i] <= m)
      result += m - sol[i] + 1;
  cout << result;
  return 0;
}
