#include <iostream>
#include <set>
#include <map>
#include <fstream>

using namespace std;
ifstream in ("input.in");

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 200000;

struct Point{
  int x;
  int y;
};
Point v[1 + nmax];
int ptr = 0;

set<pair<int,int>> col[1 + nmax];
set<pair<int,int>> lin[1 + nmax];
int state[1 + nmax];
int extremep = 0, internalp = 0;

void recalculatePoint(int id){
  int x = v[id].x, y = v[id].y;
  int edgex = 0, edgey = 0;
  if(col[y].upper_bound({x, id}) != col[y].end())
    edgey++;
  if(col[y].begin()->first < x)
    edgey++;
  if(lin[x].upper_bound({y, id}) != lin[x].end())
    edgex++;
  if(lin[x].begin()->first < y)
    edgex++;

  if(state[id] == -1)
    internalp--;
  else if(state[id] == 1)
    extremep--;
  if(edgex < 2 && edgey < 2) {
    extremep++;
    state[id] = 1;
  } else if(edgex == 2 && edgey == 2) {
    internalp++;
    state[id] = -1;
  } else
    state[id] = 0;
}

map<pair<int,int>, int> freq;

void insertPoint(int x, int y){
  v[++ptr] = {x, y};
  freq[{x, y}] = ptr;
  lin[x].insert({y, ptr});
  col[y].insert({x, ptr});
  recalculatePoint(ptr);
  int id = ptr;
  set<pair<int,int>>::iterator it = col[y].upper_bound({x, id});
  if(it != col[y].end())
    recalculatePoint(it->second);
  it--;
  if(it != col[y].begin()) {
    it--;
    recalculatePoint(it->second);
  }

  it = lin[x].upper_bound({y, id});
  if(it != lin[x].end())
    recalculatePoint(it->second);
  it--;
  if(it != lin[x].begin()) {
    it--;
    recalculatePoint(it->second);
  }
}

void deletePoint(int x, int y){
  int id = freq[{x, y}];
  lin[v[id].x].erase({y, id});
  col[v[id].y].erase({x, id});
  if(state[id] == 1)
    extremep--;
  else if(state[id] == -1)
    internalp--;
  state[id] = 0;

  set<pair<int,int>>::iterator it = col[y].upper_bound({x, id});
  if(it != col[y].end())
    recalculatePoint(it->second);
  if(it != col[y].begin()) {
    it--;
    recalculatePoint(it->second);
  }

  it = lin[x].upper_bound({y, id});
  if(it != lin[x].end())
    recalculatePoint(it->second);
  if(it != lin[x].begin()) {
    it--;
    recalculatePoint(it->second);
  }
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n;
  cin >> n;
  for(int i = 1;i <= n; i++){
    int x, y;
    cin >> x >> y;
    insertPoint(x, y);
  }

  cout << extremep << " " << internalp << '\n';

  int m;
  cin >> m;
  for(int i = 1;i <= m; i++){
    int op, x, y;
    cin >> op >> x >> y;
    if(op == 1)
      insertPoint(x, y);
    else
      deletePoint(x, y);
    cout << extremep << " "<< internalp << '\n';
  }

  return 0;
}
