#include <iostream>
#include <vector>

using namespace std;

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 500000;
vector<int> g[1 + nmax];

int dp[1 + nmax]; // I can go only down
int dp2[1 + nmax]; // First move is above
int seen[1 + nmax];

void dfs(int node, int parent){
  seen[node] = 1;
  for(int h = 0; h < g[node].size(); h++){
    int to = g[node][h];
    if(to != parent) {
      dfs(to, node);
      dp[node] |= !dp[to];
    }
  }
}

void dfs2(int node, int parent){
  //by default we lose
  int loses = 0;
  if(dp2[node] == 1)
    loses++;

  for(int h = 0; h < g[node].size(); h++){
    int to = g[node][h];
    if(to != parent){
      if(dp[to] == 0)
        loses++;
      if(1 < loses)
        break;
    }
  }

  for(int h = 0; h < g[node].size(); h++){
    int to = g[node][h];
    if(to != parent){
      if(dp[to] == 1)
        dp2[to] = !loses;
      else
        dp2[to] = !(loses - 1);
      dfs2(to, node);
    }
  }
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, m;
  cin >> n >> m;
  for(int i = 1;i <= m; i++){
    int x, y;
    cin >> x >> y;
    g[x].push_back(y);
    g[y].push_back(x);
  }
  for(int i = 1;i <= n; i++)
    if(seen[i] == 0) {
      dfs(i, 0);
      dfs2(i, 0);
    }
  string s;
  for(int i = 1;i <= n; i++)
    if(dp[i] == 0 && dp2[i] == 0)
      s += "1";
    else
      s += "0";
  cout << s;
  return 0;
}
