#include <iostream>
#include <vector>

using namespace std;

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000000;

int g[1 + nmax];
int nxt[1 + nmax];
int start[1 + nmax], last[1 + nmax];

int dp[1 + nmax]; // I can go only down
int dp2[1 + nmax]; // First move is above
int seen[1 + nmax];

void dfs(int node, int parent){
  seen[node] = 1;

  int ptr = start[node];

  while(true){
    int to = g[ptr];
    if(to != parent) {
      dfs(to, node);
      dp[node] |= !dp[to];
    }
    if(ptr == last[node])
      break;
    else
      ptr = nxt[ptr];
  }
}

void dfs2(int node, int parent){
  //by default we lose
  int loses = 0;
  if(dp2[node] == 1)
    loses++;
  int ptr = start[node];

  while(true){
    int to = g[ptr];
    if(to != parent){
      if(dp[to] == 0)
        loses++;
      if(1 < loses)
        break;
    }
    if(ptr == last[node])
      break;
    else
      ptr = nxt[ptr];
  }


  ptr = start[node];

  while(true){
    int to = g[ptr];
    if(to != parent){
      if(dp[to] == 1)
        dp2[to] = !loses;
      else
        dp2[to] = !(loses - 1);
      dfs2(to, node);
    }
    if(ptr == last[node])
      break;
    else
      ptr = nxt[ptr];
  }
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, m;
  cin >> n >> m;
  int ptr = 0;

  for(int i = 1;i <= m; i++){
    int x, y;
    cin >> x >> y;
    ++ptr;
    if(0 == start[x]) {
      g[ptr] = y;
      start[x] = ptr;
      last[x] = ptr;
    } else {
      g[ptr] = y;
      nxt[last[x]] = ptr;
      last[x] = ptr;
    }

    ++ptr;
    if(0 == start[y]){
      g[ptr] = x;
      start[y] = ptr;
      last[y] = ptr;
    } else {
      g[ptr] = x;
      nxt[last[y]] = ptr;
      last[y] = ptr;
    }
  }

  for(int i = 1;i <= n; i++)
    if(0 < start[i] && seen[i] == 0) {
      dfs(i, 0);
      dfs2(i, 0);
    }

  string s;
  for(int i = 1;i <= n; i++)
    if(dp[i] == 0 && dp2[i] == 0)
      s += "1";
    else
      s += "0";
  cout << s;
  return 0;
}
