#include <iostream>
#include <queue>

using namespace std;

const int N = 2000 + 7;
const int M = 200000 + 7;

int dir[N];

int par(int a)
{
    if (dir[a] == a)
    {
        return a;
    }
    else
    {
        return dir[a] = par(dir[a]);
    }
}

bool unite(int a, int b)
{
    a = par(a);
    b = par(b);
    if (a != b)
    {
        dir[a] = b;
        return 1;
    }
    else
    {
        return 0;
    }
}

int n;
int m;
int x[M];
int y[M];
int cnt[N][N];
bool cnx;
bool seen[N];


void ck()
{
    for (int i = 1; i <= n; i++)
    {
        seen[i] = 0;
    }
    seen[1] = 1;
    queue<int> q;
    q.push(1);
    while (!q.empty())
    {
        int a = q.front();
        q.pop();
        for (int b = 1; b <= n; b++)
        {
            if (cnt[a][b] && seen[b] == 0)
            {
                seen[b] = 1;
                q.push(b);
            }
        }
    }
    cnx = 1;
    for (int i = 1; i <= n; i++)
    {
        if (seen[i] == 0)
        {
            cnx = 0;
            break;
        }
    }
}

void add(int id)
{
    int a = x[id];
    int b = y[id];
    cnt[a][b]++;
    cnt[b][a]++;
    ck();
}

void del(int id)
{
    int a = x[id];
    int b = y[id];
    cnt[a][b]--;
    cnt[b][a]--;
    ck();
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    int ans = 0, last = 0;
    for (int i = 1; i <= m; i++)
    {
        while (last <= m && (cnx == 0))
        {
            last++;
            add(last);
        }
        if (last > m)
        {
            break;
        }
        del(i);
        ans += m + 1 - last;
    }
    cout << ans << "\n";
}
