#include <iostream>
#include <queue>
#include <random>
#include <set>

using namespace std;

typedef long long ll;
mt19937 rng(228);
const int N = 2000 + 7;
const int M = 200000 + 7;

int n;
int m;
int x[M];
int y[M];
int cnt[N][N];
bool cnx;
int last[N];
int now = 0;
int q[N], top;
set<int> dir[N];

void ck()
{
    now++;
    int a = rng() % n + 1;
    last[a] = now;
    queue<int> q;
    q.push(a);
    int nt = 1;
    while (!q.empty())
    {
        int a = q.front();
        q.pop();
        for (auto &b : dir[a])
        {
            if (cnt[a][b] && last[b] != now)
            {
                nt++;
                last[b] = now;
                q.push(b);
            }
        }
    }
    cnx = (nt == n);
}

void add(int id)
{
    int a = x[id];
    int b = y[id];
    cnt[a][b]++;
    cnt[b][a]++;
    if (cnt[a][b] == 1)
    {
        dir[a].insert(b);
        dir[b].insert(a);
        ck();
    }
}

void del(int id)
{
    int a = x[id];
    int b = y[id];
    cnt[a][b]--;
    cnt[b][a]--;
    if (cnt[a][b] == 0)
    {
        dir[a].erase(b);
        dir[b].erase(a);
        ck();
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    ll ans = 0;
    int last = 0;
    for (int i = 1; i <= m; i++)
    {
        while (last <= m && (cnx == 0))
        {
            last++;
            add(last);
        }
        if (last > m)
        {
            break;
        }
        del(i);
        ans += m + 1 - last;
    }
    cout << ans << "\n";
}
