#include <iostream>
#include <random>
#include <vector>
#include <queue>
#include <unordered_set>

using namespace std;

typedef long long ll;
mt19937 rng(228);
const int N = 200 + 7;
const int M = 200000 + 7;
int n;
int m;
int x[M];
int y[M];
int w[N][N];
int last[N];
queue<int> q;
bool cnx;
int fk = 0;
int seen;
int po;
unordered_set<int> g[N];

void calc()
{
    fk++;
    int root = rng() % n + 1;
    seen = 1;
    last[root] = fk;
    q.push(root);
    while (!q.empty())
    {
        int a = q.front();
        q.pop();
        for (auto &b : g[a])
        {
            if (last[b] < fk)
            {
                last[b] = fk;
                seen++;
                q.push(b);
            }
        }
    }
    cnx = (seen == n);
}

void add(int i)
{
    int a = x[i];
    int b = y[i];
    w[a][b]++;
    if (w[a][b] == 1)
    {
        po++;
        g[a].insert(b);
        g[b].insert(a);
        if (po < n - 1)
        {
            return;
        }
        if (cnx == 0)
        {
            calc();
        }
    }
}

void del(int i)
{
    int a = x[i];
    int b = y[i];
    w[a][b]--;
    if (w[a][b] == 0)
    {
        po--;
        g[a].erase(b);
        g[b].erase(a);
        calc();
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        g[i].rehash(n);
    }
    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    ll ans = 0;
    int last = 0;
    for (int i = 1; i <= m; i++)
    {
        while (cnx == 0)
        {
            if (last == m)
            {
                cout << ans << "\n";
                return 0;
            }
            last++;
            add(last);
        }
        del(i);
        ans += m + 1 - last;
    }
    cout << ans << "\n";
    return 0;
}
