#include <iostream>
#include <vector>
#include <deque>

using namespace std;

typedef long long ll;
const int N = 200 + 7;
const int M = 200000 + 7;
int n;
int m;
int x[M];
int y[M];
deque<int> g[N];

void add(int i)
{
    int a = x[i];
    int b = y[i];
    g[a].push_back(b);
    g[b].push_back(a);
}

void del(int i)
{
    int a = x[i];
    int b = y[i];
    g[a].pop_front();
    g[b].pop_front();
}

int t[N];
int op;

int get(int a)
{
    if (t[a] == a)
    {
        return a;
    }
    else
    {
        return t[a] = get(t[a]);
    }
}

void unite(int a, int b)
{
    a = get(a);
    b = get(b);
    if (a != b)
    {
        op--;
        t[a] = b;
    }
}

bool cnx()
{
    for (int i = 1; i <= n; i++)
    {
        t[i] = i;
    }
    op = n;
    for (int i = 1; i <= n; i++)
    {
        if ((int) g[i].size() >= 1) unite(i, g[i][0]);
        if ((int) g[i].size() >= 2) unite(i, g[i][1]);
        if ((int) g[i].size() >= 3) unite(i, g[i][(int) g[i].size() - 1]);
        if ((int) g[i].size() >= 4) unite(i, g[i][(int) g[i].size() - 2]);
    }
    return (op == 1);
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= m; i++)
    {
        cin >> x[i] >> y[i];
    }
    ll ans = 0;
    int last = 0;
    for (int i = 1; i <= m; i++)
    {
        while (cnx() == 0)
        {
            if (last == m)
            {
                cout << ans << "\n";
                return 0;
            }
            last++;
            add(last);
        }
        del(i);
        ans += m + 1 - last;
    }
    cout << ans << "\n";
}
