#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rng(100);
const int N = (int) 2e5 + 7;
int n;
int m;
vector<int> g[N];
bool u[N];
vector<int> path;
int ans[N];

void rst_task1()
{
    path.clear();
    for (int i = 1; i <= n; i++)
    {
        u[i] = 0;
    }
}

void dfs_task1(int a)
{
    u[a] = 1;
    path.push_back(a);
    for (auto &b : g[a])
    {
        if (u[b] == 0)
        {
            dfs_task1(b);
        }
    }
}

int dp[N];
int ok[N];
void dfs_task2(int a, int p)
{
    int vecs = (int) g[a].size() - (p != -1);
    if (vecs == 0)
    {
        dp[a] = 0;
        return;
    }
    dp[a] = 0;
    for (auto &b : g[a])
    {
        if (b != p)
        {
            dfs_task2(b, a);
            if (dp[b] == 0)
            {
                dp[a] = 1;
            }
        }
    }
}

void run()
{
    for (int i = 1; i <= n; i++)
    {
        int cnt_0 = 0;
        for (auto &j : g[i])
        {
            cnt_0 += (dp[j] == 0);
        }
        if (cnt_0 == 1)
        {
          ///  cout << " : " << i << "\n";
            for (auto &j : g[i])
            {
                if (dp[j] == 0)
                {
                    ok[j] = 1;
                }
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int cnt_deg1 = 0;
    for (int i = 1; i <= n; i++)
    {
        cnt_deg1 += ((int) g[i].size() == 1);
    }
    if (cnt_deg1 == 2) /// lant, task 1
    {
        int root;
        for (int i = 1; i <= n; i++)
        {
            if ((int) g[i].size() == 1)
            {
                root = i;
            }
        }
        rst_task1();
        dfs_task1(root);
        for (int i = 1; i <= n; i++)
        {
            int a = path[i - 1];
            if (i == 1 || i == n)
            {
                if (n % 2 == 1)
                {
                    ans[a] = 1;
                }
                else
                {
                    ans[a] = 0;
                }
            }
            else
            {
                int l1 = i - 1;
                int l2 = n - i;
                if (l1 % 2 == 1 || l2 % 2 == 1)
                {
                    ans[a] = 0;
                }
                else
                {
                    ans[a] = 1;
                }
            }
        }
        for (int i = 1; i <= n; i++)
        {
            cout << ans[i];
        }
        cout << "\n";
        return 0;
    }
    /// task 2
    dfs_task2(1, -1);
    for (int i = 1; i <= n; i++)
    {
        ok[i] = dp[i];
    }
    run();
    for (int i = 1; i <= n; i++)
    {
        cout << (ok[i] ^ 1);
    }
    cout << "\n";
    return 0;
}
