#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 rng(100);
const int N = (int) 2e5 + 7;
int n;
int m;
vector<int> g[N];
bool u[N];
vector<int> path;
int ans[N];

int up[N];
int down[N];
int c[N];
void dfs(int a, int p)
{
    int vecs = (int) g[a].size() - (p != -1);
    if (vecs == 0)
    {
        down[a] = 0;
        return;
    }
    down[a] = 0;
    for (auto &b : g[a])
    {
        if (b != p)
        {
            dfs(b, a);
            if (down[b] == 0)
            {
                down[a] = 1;
                c[a]++;
            }
        }
    }
}

void run(int a, int p)
{
    vector<int> kd;
    for (auto &b : g[a])
    {
        if (b != p)
        {
            kd.push_back(b);
        }
    }
    if (p != -1 && up[p] == 0)
    {
        up[a] = 1;
    }
    if (c[p] == 1 && down[a] == 0)
    {
        up[a] = 1;
    }
    for (auto &b : kd)
    {
        run(b, a);
    }
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    /// task 2
    dfs(1, -1);
    run(1, -1);
    for (int i = 1; i <= n; i++)
    {
        bool ok;
        if (down[i] || up[i])
        {
            ok = 1;
        }
        else
        {
            ok = 0;
        }
        cout << (ok ^ 1);
    }
    cout << "\n";
    return 0;
}
