#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int N_MAX = 50002;
const int M_MAX = 200002;

int n, m;

struct Edge
{
    int u, v;
};

struct Change
{
    int node;
    int root;
    int time;
};

stack <Change> changes;
int currentTime;

Edge edges[M_MAX];

ll ans;

int root[N_MAX];

int find_root (int node)
{
    if(root[node] == node)
        return node;
    changes.push(Change{node, root[node], currentTime});
    return root[node] = find_root(root[node]);
}

void join (int u, int v)
{
    u = root[u];
    v = root[v];
    if(u == v)
        return;
    changes.push(Change{u, root[u], currentTime});
    root[u] = v;
}

void undo ()
{
    while(!changes.empty() && changes.top().time > currentTime)
    {
        root[changes.top().node] = changes.top().root;
        changes.pop();
    }
}

stack <int> st;

deque <int> dq;

void add (int index)
{
    if(find_root(edges[index].u) == find_root(edges[index].v))
    {
        dq.push_back(index);
        return;
    }
    st.push(index);
    currentTime = st.size();
    join(edges[index].u, edges[index].v);
}

stack <int> st1;

void erase (int index)
{
    while(!st.empty() && st.top() != index)
    {
        st1.push(st.top());
        st.pop();
        currentTime = st.size();
        undo();
    }
    if(!st.empty())
    {
        st.pop();
        currentTime = st.size();
        undo();
    }
    while(!st1.empty())
    {
        st.push(st1.top());
        currentTime = st.size();
        join(edges[st.top()].u, edges[st.top()].v);
        st1.pop();
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
        cin >> edges[i].u >> edges[i].v;
    int pos = 0;
    for(int i = 1; i <= n; i++)
        root[i] = i;
    for(int i = 1; i <= m; i++)
    {
        while(dq.front() < i)
            dq.pop_front();
        if(!dq.empty() && st.size() < n - 1)
            add(dq.front());
        while(pos < m && st.size() < n - 1)
        {
            pos++;
            add(pos);
        }
        if(st.size() == n - 1)
            ans += m - pos + 1;
        erase(i);
    }
    cout << ans << "\n";
    return 0;
}
