#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 500002;
const int BUFFER_SIZE = 1000000;

char buffer[BUFFER_SIZE];
int bpos = BUFFER_SIZE - 1;

char read_char ()
{
    bpos++;
    if(bpos == BUFFER_SIZE)
    {
        fread(buffer, sizeof(char), BUFFER_SIZE, stdin);
        bpos = 0;
    }
    return buffer[bpos];
}
int read_int ()
{
    char c;
    while(!isdigit(c = read_char()));
    int ans = 0;
    while(isdigit(c))
    {
        ans = ans * 10 + c - '0';
        c = read_char();
    }
    return ans;
}

int n, m;

vector <int> edges[N_MAX];

bool up[N_MAX], down1[N_MAX], down2[N_MAX];
int p[N_MAX];

bool visited[N_MAX];

void dfsDown (int node, int parent = -1)
{
    visited[node] = true;
    for(int u : edges[node])
        if(u != parent)
        {
            dfsDown(u, node);
            if(down1[u] == false)
            {
                down2[node] = down1[node];
                down1[node] = true;
                p[node] = u;
            }
        }
}

void dfsUp (int node, int parent = -1)
{
    if(parent != -1)
    {
        up[node] = true;
        if(edges[parent].size() - (parent != 1) > 1)
        {
            if(p[parent] == node)
                up[node] &= !down2[parent];
            else
                up[node] &= !down1[parent];
        }
        up[node] &= !up[parent];
    }
    for(int u : edges[node])
        if(u != parent)
            dfsUp(u, node);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n = read_int();
    m = read_int();
    for(int i = 1; i <= m; i++)
    {
        int u, v;
        u = read_int();
        v = read_int();
        edges[u].push_back(v);
        edges[v].push_back(u);
    }
    for(int i = 1; i <= n; i++)
        if(visited[i] == false)
        {
            dfsDown(i);
            dfsUp(i);
        }
    for(int i = 1; i <= n; i++)
        cout << !(up[i] | down1[i]);
    cout << "\n";
    return 0;
}
