#include <iostream>
#include <time.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>


#define ll long long
#define all(x) x.begin(), x.end()
#define ld long double


using namespace std;


struct pointx {
    int x, y, i;
    pointx(int x, int y, int ind){
        this->x = x;
        this->y = y;
        this->i = ind;
    }
};


struct pointy {
    int x, y, i;
    pointy(int x, int y, int ind){
        this->x = x;
        this->y = y;
        this->i = ind;
    }
};


bool operator<(const pointx &lhs, const pointx &rhs){
    return lhs.x < rhs.x;
}

bool operator<(const pointy &lhs, const pointy &rhs){
    return lhs.y < rhs.y;
}


const int maxn = 2e5, maxq = 2e5, maxxy = 1e5;




set<pointy> xs[maxxy + 1];
set<pointx> ys[maxxy + 1];

int n, q;
map<pair<int, int>, int> ind;
bool extremal[maxn], inner[maxn];
int e, in;

void check_inner(const pointx &p) {
    bool now = !xs[p.x].empty() && !ys[p.y].empty() && ((*xs[p.x].begin()).y < p.y && (*xs[p.x].rbegin()).y > p.y) && ((*ys[p.y].begin()).x < p.x && (*ys[p.y].rbegin()).x > p.x);
    if(now && !inner[p.i]){
        in++;
        inner[p.i] = true;
    }
    if(!now && inner[p.i]){
        in--;
        inner[p.i] = false;
    }
}

void check_extr(const pointx &p) {
    bool now = (xs[p.x].empty() || ((*xs[p.x].begin()).y >= p.y || (*xs[p.x].rbegin()).y <= p.y)) && (ys[p.y].empty() || ((*ys[p.y].begin()).x >= p.x || (*ys[p.y].rbegin()).x <= p.x));
    if(now && !extremal[p.i]){
        e++;
        extremal[p.i] = true;
    }
    if(!now && extremal[p.i]){
        e--;
        extremal[p.i] = false;
    }
}

void check_inner(const pointy &p) {
     bool now = !xs[p.x].empty() && !ys[p.y].empty() && ((*xs[p.x].begin()).y < p.y && (*xs[p.x].rbegin()).y > p.y) && ((*ys[p.y].begin()).x < p.x && (*ys[p.y].rbegin()).x > p.x);
    if(now && !inner[p.i]){
        in++;
        inner[p.i] = true;
    }
    if(!now && inner[p.i]){
        in--;
        inner[p.i] = false;
    }
}

void check_extr(const pointy &p) {

    bool now = (xs[p.x].empty() || ((*xs[p.x].begin()).y >= p.y || (*xs[p.x].rbegin()).y <= p.y)) && (ys[p.y].empty() || ((*ys[p.y].begin()).x >= p.x || (*ys[p.y].rbegin()).x <= p.x));
    if(now && !extremal[p.i]){
        e++;
        extremal[p.i] = true;
    }
    if(!now && extremal[p.i]){
        e--;
        extremal[p.i] = false;
    }
}



vector<pointx> all_p;

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin >> n;
    for(int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        pointx px(x, y, i);
//        if(x == 1 && y == 2){
//            cout << "find\n";
//        }
        pointy py(x, y, i);
        xs[x].insert(py);
        ys[y].insert(px);
//        for(auto [x1, y1, i1]: xs[x]){
//            cout << "point: " << x1 << " " << y1 << " " << i1 << endl;
//        }
        all_p.push_back(px);
        ind[{x, y}] = i;
    }
    for(auto p: all_p){
        check_inner(p);
        check_extr(p);
    }
    cin >> q;
    cout << e << " " << in << endl;
    int now = n;
    for(int i = n; i < n + q; ++i) {
        int t, x, y;
        cin >> t >> x >> y;
        if(t == 1) {
            pointx px(x, y, now);
            pointy py(x, y, now);
            ind[{x, y}] = now;
            auto xleft_p = xs[x].lower_bound(py);
            auto yleft_p = ys[y].lower_bound(px);
            xs[x].insert(py);
            ys[y].insert(px);
            ind[{x, y}] = i;
            if(xleft_p != xs[x].end()){
                auto xleft = *xleft_p;
                auto xright_p = xleft_p++;
                check_extr(xleft);
                check_inner(xleft);
                if(xright_p != xs[x].end()) {
                    auto xright  = *xright_p;
                    check_extr(xright);
                    check_inner(xright);
                }
            }

            if(yleft_p != ys[y].end()){
                auto yleft = *yleft_p;
                auto yright_p = yleft_p++;
                check_extr(yleft);
                check_inner(yleft);
                if(yright_p != ys[y].end()){
                    auto yright = *yright_p;
                    check_extr(yright);
                    check_inner(yright);
                }
            }
            check_extr(px);
            check_inner(px);
        }else{
            pointx px(x, y, ind[{x, y}]);
            pointy py(x, y, ind[{x, y}]);
            xs[x].erase(py);
            ys[y].erase(px);
            auto xleft_p = xs[x].lower_bound(py);
            auto yleft_p = ys[y].lower_bound(px);
            for(auto [x1, y1, i1]: xs[x]){
                cout << "point: " << x1 << " " << y1 << " " << i1 << endl;
            }
            if(xleft_p != xs[x].end()){
                auto xleft = *xleft_p;
                auto xright_p = xleft_p++;
//                cout << "xleft: " << xleft.x << " " << xleft.y << " " << xleft.i << endl;
                check_extr(xleft);
                check_inner(xleft);
                if(xright_p != xs[x].end()) {
                    auto xright  = *xright_p;
//                  cout << "xright: " << xright.x << " " << xright.y << " " << xright.i << endl;
                    check_extr(xright);
                    check_inner(xright);
                }
            }
            if(yleft_p != ys[y].end()){
                auto yleft = *yleft_p;
                auto yright_p = yleft_p++;
//                cout << "yleft: " << yleft.x << " " << yleft.y << " " << yleft.i << endl;
                check_extr(yleft);
                check_inner(yleft);
                if(yright_p != ys[y].end()){
                    auto yright = *yright_p;
    //                cout << "yright: " << yright.x << " " << yright.y << " " << yright.i << endl;
                    check_extr(yright);
                    check_inner(yright);
                }
            }

            if(extremal[ind[{x, y}]])
                e--;
            if(inner[ind[{x, y}]])
                in --;
        }
        cout << e << " " << in << endl;
    }
    return 0;
}
