#include<iostream>
#include<vector>
#include<deque>
#include<iomanip>
#include<string>
#include<numeric>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>

using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define ll long long
#define ld long double
#define P pair<int, int>

const int N = 2e5 + 5;

map<P, int> ord;
bool bestx[N], besty[N], in1[N], in2[N];
set<int> atx[N], aty[N];
int cnt1, cnt2;

void relax(int x, int y) {
    if (y == *atx[x].begin() || y == *atx[x].rbegin()) {
        bestx[ord[{x, y}]] = true;
    } else {
        bestx[ord[{x, y}]] = false;
    }
    if (x == *aty[y].begin() || x == *aty[y].rbegin()) {
        besty[ord[{x, y}]] = true;
    } else {
        besty[ord[{x, y}]] = false;
    }
    int id = ord[{x, y}];
    if (bestx[id] && besty[id]) {
        if (!in1[id]) cnt1++;
        in1[id] = true;
    } else {
        if (in1[id]) cnt1--;
        in1[id] = false;
    }
    if (!bestx[id] && !besty[id]) {
        if (!in2[id]) cnt2++;
        in2[id] = true;
    } else {
        if (in2[id]) cnt2--;
        in2[id] = false;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        vector<P> torelax;
        if (!atx[x].empty()) {
            torelax.pb({x, *atx[x].begin()});
            torelax.pb({x, *atx[x].rbegin()});
        }
        if (!aty[y].empty()) {
            torelax.pb({*aty[y].begin(), y});
            torelax.pb({*aty[y].rbegin(), y});
        }
        ord[{x, y}] = i;
        torelax.pb({x, y});
        atx[x].insert(y);
        aty[y].insert(x);
        for (auto p : torelax) {
            relax(p.x, p.y);
        }
    }
    cout << cnt1 << " " << cnt2 << '\n';
    int q;
    cin >> q;
    for (int i = n; i < n + q; i++) {
        int t, x, y;
        cin >> t >> x >> y;
        vector<P> torelax;
        if (t == 1) {
            if (!atx[x].empty()) {
                torelax.pb({x, *atx[x].begin()});
                torelax.pb({x, *atx[x].rbegin()});
            }
            if (!aty[y].empty()) {
                torelax.pb({*aty[y].begin(), y});
                torelax.pb({*aty[y].rbegin(), y});
            }
            ord[{x, y}] = i;
            torelax.pb({x, y});
            atx[x].insert(y);
            aty[y].insert(x);
        } else {
            int id = ord[{x, y}];
            if (in1[id]) {
                cnt1--;
            }
            if (in2[id]) {
                cnt2--;
            }
            atx[x].erase(y);
            aty[y].erase(x);
            if (!atx[x].empty()) {
                torelax.pb({x, *atx[x].begin()});
                torelax.pb({x, *atx[x].rbegin()});
            }
            if (!aty[y].empty()) {
                torelax.pb({*aty[y].begin(), y});
                torelax.pb({*aty[y].rbegin(), y});
            }
        }
        for (auto p : torelax) {
            relax(p.x, p.y);
        }
        cout << cnt1 << " " << cnt2 << '\n';
    }
    return 0;
}
