#include <bits/stdc++.h>
using namespace std;

namespace sol1 {


	vector<set<pair<int, int>>> g; // {to, ind}

	vector<int> path;

	bool dfs(int v, int tar, int p = -1) {
		if (v == tar) {
			return true;
		}
		for (auto u : g[v]) {
			if (u.first != p) {
				path.push_back(u.second);
				if (dfs(u.first, tar, v)) {
					return true;
				}
				path.pop_back();
			}
		}
		return false;
	}

	const int MAXN = 50000 + 228;
	int parent[MAXN];
	int sz[MAXN];


	int get(int v) {
		if (v == parent[v]) {
			return v;
		}
		return parent[v] = get(parent[v]);
	}

	int cnt;

	void unite(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return;
		cnt--;
		if (sz[b] > sz[a]) {
			swap(a, b);
		}
		parent[b] = a;
		if (sz[a] == sz[b]) {
			sz[a]++;
		}
	}


	void solve(int n, int m) {
		g.resize(n);
		vector<pair<int, int>> edges(m);
		for (int i = 0; i < m; i++) {
			cin >> edges[i].first >> edges[i].second;
			edges[i].first--;
			edges[i].second--;
		}
		vector<int> delTime(m, INT_MAX);
		for (int i = 0; i < m; i++) {
			int a = edges[i].first;
			int b = edges[i].second;
			if (a == b) {
				delTime[i] = -1;
				continue;
			}
			path.clear();
			if (dfs(a, b)) {
				int min_t = INT_MAX;
				for (int el : path) {
					min_t = min(min_t, el);
				}
				int aa = edges[min_t].first;
				int bb = edges[min_t].second;
				delTime[min_t] = i;
				g[aa].erase({bb, min_t});
				g[bb].erase({aa, min_t});
			}
			g[a].insert({b, i});
			g[b].insert({a, i});
		}
		long long ans = 0;
		int r = 0;
		cnt = n;
		for (int i = 0; i < n; i++) {
			parent[i] = i;
		}
		while (cnt != 1 && r < m) {
			unite(edges[r].first, edges[r].second);
			r++;
		}
		for (int l = 0; l < m; l++) {
			ans += m - r + 1;
			while (r <= delTime[l] && r <= m) {
				r++;
			}
			if (r > m) {
				break;
			}
		}
		cout << ans << endl;


	}
}

namespace sol2 {

	const int MAXN = 50000 + 228;

	int parent[MAXN];
	int sz[MAXN];

	int get(int v) {
		if (parent[v] == v)
			return v;
		return parent[v] = get(parent[v]);
	}

	int cnt;

	void unite(int u, int v) {
		u = get(u);
		v = get(v);
		if (u == v)
			return;
		cnt--;
		if (sz[v] > sz[u]) {
			swap(u, v);
		}
		parent[v] = u;
		if (sz[v] == sz[u]) {
			sz[u]++;
		}
	}


	void solve(int n, int m) {
		ios_base::sync_with_stdio(0);
		cin.tie(0);
		cout.tie(0);
		vector<pair<int, int>> edges(m);
		for (int i = 0; i < m; i++) {
			cin >> edges[i].first >> edges[i].second;
			edges[i].first--;
			edges[i].second--;
		}
		int ans = 0;
		for (int l = 0; l < m; l++) {
			for (int i = 0; i < n; i++) {
				parent[i] = i;
			}
			cnt = n;
			int r;
			for (r = l; r <  m && cnt != 1; r++) {
				unite(edges[r].first, edges[r].second);
			}
			if (cnt == 1)
			ans += m - r + 1;
		}
		cout << ans << endl;
	}
}

int main() {
	int n ,m;
	cin >> n >> m;
	if (m <= 5000) {
		sol2::solve(n, m);
	} else {
		sol1::solve(n, m);
	}
}
