#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5;
vector<int> good[MAXN];
int p[MAXN], sz[MAXN];
pair<int, int> ed[MAXN];

int cnt;

int get(int v) {
    if (v == p[v]) {
        return v;
    }
    p[v] = get(p[v]);
    return p[v];
}

bool join(int u, int v) {
    u = get(u); v = get(v);
    if (u == v) {
        return false;
    }
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    cnt--;
    p[v] = u;
    sz[u] += sz[v];
    return true;
}

void build(int l, int r, int h, int num) {
    for (int i = l; i < r; ++i) {
        int u = ed[i].first;
        int v = ed[i].second;
        p[u] = u;
        p[v] = v;
        sz[u] = 1;
        sz[v] = 1;
    }
    for (int i = l; i < r; ++i) {
        bool f = join(ed[i].first, ed[i].second);
        if (f) {
            good[num].push_back(i);
        }
    }
    if (r - l == 1) {
        return;
    }
    int m = (l + r) / 2;
    int ch = num - ((r - l) * 2 - 1);
    build(l, m, h + 1, ch + (m - l) * 2 - 1);
    build(m, r, h + 1, ch + (r - l) * 2 - 2);
}

int solve(int v, int l, int r, int num) {
    if (r - l == 1) {
        // cout << v << endl;
        join(ed[v].first, ed[v].second);
        // cout << "  " << cnt << endl;
        return 1;
    }
    int m = (r + l) / 2;
    if (v >= m) {
        return solve(v, m, r, num - 1);
    }
    int ch = num - ((r - l) * 2 - 1);
    int res1 = solve(v, l, m, ch + (m - l) * 2 - 1);
    if (cnt == 1) {
        return res1;
    }
    for (auto elem : good[num - 1]) {
        join(ed[elem].first, ed[elem].second);
        // cout << elem << endl;
        // cout << "  " << cnt << endl;
        if (cnt == 1) {
            return elem - v + 1;
        }
    }
    return r - v;
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> ed[i].first >> ed[i].second;
        ed[i].first--; ed[i].second--;
    }
    build(0, m, 0, 2 * m - 1);
    int64_t ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            p[j] = j;
            sz[j] = 1;
        }
        cnt = n;
        int x = solve(i, 0, m, 2 * m - 1);
        if (cnt == 1) {
            ans += m - x - i + 1;
        } else {
            break;
        }
    }
    cout << ans;
    return 0;
}
