#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("O3")
#pragma GCC target("tune=native,sse,sse2,popcnt")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define int long long

class DSU {
public:
    int n;
    vector<int> p;
    vector<int> rank;
    int comps;

    DSU(int sz) {
        n = sz;
        comps = n;
        p.resize(n);
        for(int i = 0; i < n; i++) {
            p[i] = i;
        }
        rank.resize(n);
    }

    int get(int v) {
        if(p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if(u != v) {
            if(rank[u] > rank[v]) {
                swap(u, v);
            }
            p[u] = v;
            if(rank[u] == rank[v]) {
                rank[v]++;
            }
            comps--;
        }
    }
};

const int K = 450;

signed main() {
    int n, m;
    cin >> n >> m;

    vector< pair<int, int> > edges(m);
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges[i] = make_pair(u, v);
    }

    int ans = 0;
    for(int block = K; block < m; block += K) {
        DSU dsu(n), dsu1(n);
        for(int j = block; j <= m; j++) {
            if(j % K == 0) {
                if(dsu.comps <= K + 1) {
                    vector<int> vv;
                    for(int i = block - 1; i >= 0 && i >= block - K; i--) {
                        vv.push_back(dsu.get(edges[i].first));
                        vv.push_back(dsu.get(edges[i].second));
                    }
                    sort(vv.begin(), vv.end());
                    vv.erase(unique(vv.begin(), vv.end()), vv.end());
#                   define FIND(x) (lower_bound(vv.begin(), vv.end(), dsu.get((x))) - vv.begin())

                    DSU new_dsu(vv.size());
                    for(int i = block - 1; i >= 0 && i >= block - K; i--) {
                        new_dsu.unite(FIND(edges[i].first), FIND(edges[i].second));
                        dsu1.unite(edges[i].first, edges[i].second);
                        if(new_dsu.comps == 1 && dsu1.comps > 1) {
                            vector<int> vv;
                            for(int jj = j - K; jj < j; jj++) {
                                vv.push_back(dsu1.get(edges[jj].first));
                                vv.push_back(dsu1.get(edges[jj].second));
                            }
                            sort(vv.begin(), vv.end());
                            vv.erase(unique(vv.begin(), vv.end()), vv.end());
#                           define FIND(x) (lower_bound(vv.begin(), vv.end(), dsu1.get((x))) - vv.begin())

                            DSU new_dsu1(vv.size());
                            for(int jj = j - K; jj < j; jj++) {
                                new_dsu1.unite(FIND(edges[jj].first), FIND(edges[jj].second));
                                if(new_dsu1.comps == 1) {
                                    ans += m - jj;
                                    //cout << "Ans for " << i + 1 << ": " << i + 1 << ".." << jj + 1 << endl;
                                    break;
                                }
                            }
                        }
                    }
                }
                dsu1 = dsu;
            }
            if(j != m) {
                dsu.unite(edges[j].first, edges[j].second);
            }
        }

        for(int i = block - 1; i >= 0 && i >= block - K; i--) {
            dsu.unite(edges[i].first, edges[i].second);
            dsu1.unite(edges[i].first, edges[i].second);
            if(dsu.comps == 1 && dsu1.comps > 1) {
                vector<int> vv;
                for(int jj = m - m % K; jj < m; jj++) {
                    vv.push_back(dsu1.get(edges[jj].first));
                    vv.push_back(dsu1.get(edges[jj].second));
                }
                sort(vv.begin(), vv.end());
                vv.erase(unique(vv.begin(), vv.end()), vv.end());
#               define FIND(x) (lower_bound(vv.begin(), vv.end(), dsu1.get((x))) - vv.begin())

                DSU new_dsu1(vv.size());
                for(int jj = m - m % K; ; jj++) {
                    new_dsu1.unite(FIND(edges[jj].first), FIND(edges[jj].second));
                    if(new_dsu1.comps == 1) {
                        ans += m - jj;
                        //cout << "Ans for " << i + 1 << ": " << i + 1 << ".." << jj + 1 << endl;
                        break;
                    }
                }
            }
        }
    }

    for(int block = 0; block < m; block += K) {
        for(int i = block; i < block + K && i < m; i++) {
            DSU dsu(n);
            for(int j = i; j < block + K && j < m; j++) {
                dsu.unite(edges[j].first, edges[j].second);
                if(dsu.comps == 1) {
                    ans += m - j;
                    //cout << "Ans for " << i + 1 << ": " << i + 1 << ".." << j + 1 << endl;
                    break;
                }
            }
        }
    }

    cout << ans;
    return 0;
}

// 4 4 1 2 2 4 1 3 1 4
