#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("O3")
#pragma GCC target("tune=native,sse,sse2,popcnt")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define int long long

const int MAXN = 1000000;
const int MAXM = 1000000;

int n, m;
int* adj[MAXN];
int edges_to[MAXM];
int count_adj[MAXN];
int count_adj1[MAXN];
bool dpe[MAXM];
bool used[MAXM];

void dfs(int e) {
    used[e] = true;

    int u = edges_to[e];
    for(int i = 0; i < count_adj[u]; i++) {
        int p = adj[u][i];
        if(p != (e ^ 1)) {
            if(!used[p]) {
                dfs(p);
            }
            dpe[e] = dpe[e] || !dpe[p];
            if(dpe[e]) {
                break;
            }
        }
    }
}

signed main() {
    scanf("%lld%lld", &n, &m);
    for(int i = 0; i < m * 2; i += 2) {
        int u, v;
        scanf("%lld%lld", &u, &v);
        u--; v--;
        edges_to[i] = v;
        edges_to[i + 1] = u;
        count_adj[u]++;
        count_adj[v]++;
    }
    for(int i = 0; i < n; i++) {
        adj[i] = (int*)malloc(count_adj[i] * sizeof(int));
    }
    for(int i = 0; i < m * 2; i += 2) {
        int v = edges_to[i];
        int u = edges_to[i + 1];
        adj[u][count_adj1[u]++] = i;
        adj[v][count_adj1[v]++] = i + 1;
    }

    for(int i = 0; i < m * 2; i++) {
        dpe[i] = false;
        used[i] = false;
    }
    for(int i = 0; i < m * 2; i++) {
        if(!used[i]) {
            dfs(i);
        }
    }

    for(int u = 0; u < n; u++) {
        bool ans = true;
        for(int i = 0; i < count_adj[u]; i++) {
            ans = ans && dpe[adj[u][i]];
        }
        printf("%d", ans ? 1 : 0);
    }

    return 0;
}
