#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("O3")
#pragma GCC target("tune=native,sse,sse2,popcnt")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <queue>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define int long long

int n, m;
vector< unordered_map<int, int> > adj;
vector<bool> used;


class DSU {
public:
    int n;
    vector<int> p;
    vector<int> rank;
    int comps;

    DSU(int sz) {
        n = sz;
        comps = n;
        p.resize(n);
        for(int i = 0; i < n; i++) {
            p[i] = i;
        }
        rank.resize(n);
    }

    int get(int v) {
        if(p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if(u != v) {
            if(rank[u] > rank[v]) {
                swap(u, v);
            }
            p[u] = v;
            if(rank[u] == rank[v]) {
                rank[v]++;
            }
            comps--;
        }
    }
};


signed main() {
    cin >> n >> m;
    adj.resize(n);

    vector< pair<int, int> > edges(m);
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges[i] = make_pair(u, v);
    }

    int r = 0;
    int ans = 0;
    for(int l = 0; l < m; l++) {
        if(r <= m) {
            DSU dsu(n);
            for(int i = l; i < r; i++) {
                dsu.unite(edges[i].first, edges[i].second);
            }
        }

        while(r <= m) {
            if(dsu.comps == 1) {
                break;
            }
            if(r != m) {
                dsu.unite(edges[r].first, edges[r].second);
            }
            r++;
        }
        ans += m - r + 1;
    }

    cout << ans;
    return 0;
}

// 4 4 1 2 2 4 1 3 1 4
