#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <queue>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

const int MAXN = 200000;
const int MAXM = 200000;

int n, m;
int p[MAXN];
int dsurank[MAXN];
int comps;

void dsuinit() {
    comps = n;
    for(int i = 0; i < n; i++) {
        p[i] = i;
        dsurank[i] = 0;
    }
}

int getdsu(int v) {
    if(p[v] == v) {
        return v;
    }
    return p[v] = getdsu(p[v]);
}

bool unite(int u, int v) {
    u = getdsu(u);
    v = getdsu(v);
    if(u != v) {
        if(dsurank[u] > dsurank[v]) {
            swap(u, v);
        }
        p[u] = v;
        if(dsurank[u] == dsurank[v]) {
            dsurank[v]++;
        }
        comps--;
        return true;
    }
    return false;
}

pair<int, int> edges[MAXM];
signed main() {
    scanf("%d%d", &n, &m);

    for(int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        u--; v--;
        edges[i] = make_pair(u, v);
    }

    map< pair<int, int>, int> cntof;

    int r = 0;
    long long ans = 0;
    dsuinit();
    for(int l = 0; l < m && r <= m; l++) {
        while(r <= m) {
            if(comps == 1) {
                break;
            }
            if(r != m) {
                unite(edges[r].first, edges[r].second);
                cntof[edges[r]]++;
            }
            r++;
        }
        ans += m - r + 1;
        if(--cntof[edges[l]] == 0) {
            dsuinit();
            for(int i = l + 1; i < r; i++) {
                unite(edges[i].first, edges[i].second);
            }
        }
    }

    printf("%lld", ans);
    return 0;
}

// 4 4 1 2 2 4 1 3 1 4
