#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math,unroll-all-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,sse,sse2,popcnt")

#include <iostream>
#include <cmath>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <utility>
#include <tuple>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <unordered_map>

using namespace std;

const int MAXN = 1000000;
const int MAXM = 1000000;

int n, m;
vector< pair<int, int> > adj[MAXN];
pair<int, int> edges[MAXM];
bool dpe[MAXM];
bool used[MAXM];

void dfs(int e) {
    used[e] = true;

    int u = edges[e].second;
    for(auto p: adj[u]) {
        if(p.second != (e ^ 1)) {
            if(!used[p.second]) {
                dfs(p.second);
            }
            dpe[e] = dpe[e] || !dpe[p.second];
        }
    }
}

signed main() {
    scanf("%d%d", &n, &m);
    for(int i = 0; i < m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        u--; v--;
        adj[u].emplace_back(v, i * 2);
        adj[v].emplace_back(u, i * 2 + 1);
        edges[i * 2] = make_pair(u, v);
        edges[i * 2 + 1] = make_pair(v, u);
    }

    for(int i = 0; i < m * 2; i++) {
        dpe[i] = false;
        used[i] = false;
    }
    for(int i = 0; i < m * 2; i++) {
        if(!used[i]) {
            dfs(i);
        }
    }

    for(int u = 0; u < n; u++) {
        bool ans = true;
        for(auto p: adj[u]) {
            ans = ans && dpe[p.second];
        }
        printf("%d", ans ? 1 : 0);
    }

    return 0;
}
