#include<bits/stdc++.h>

//#define int long long
#define uset unordered_set
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e4 + 5, M = 2e5 + 5;

int n, m;
pii edges[M];
uset<int> not_used;
uset<int> g[N];

void dfs(int v) {
  not_used.erase(v);
  if (sz(g[v]) < sz(not_used)) {
    for (int u : g[v]) {
      if (not_used.count(u)) {
        dfs(u);
      }
    }
  } else {
    auto it = not_used.begin();
    while (it != not_used.end()) {
      int u = *it;
      if (g[v].count(u)) {
        dfs(u);
        it = not_used.begin();
      } else {
        ++it;
      }
    }
  }
}

bool check() {
  pii mx = mp(-1, 0);
  for (int v = 1; v <= n; ++v) {
    not_used.insert(v);
    mx = max(mx, mp(sz(g[v]), v));
  }
  dfs(mx.y);
  return not_used.empty();
}

void add_edge(int i) {
  int v = edges[i].x, u = edges[i].y;
  g[v].insert(u);
  g[u].insert(v);
}

void delete_edge(int i) {
  int v = edges[i].x, u = edges[i].y;
  g[v].erase(u);
  g[u].erase(v);
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  //freopen("output.txt", "r", stdin);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  cin >> n >> m;
  for (int i = 1; i <= m; ++i) {
    cin >> edges[i].x >> edges[i].y;
  }
  int j = 0;
  ll ans = 0;
  for (int i = 1; i <= m; ++i) {
    while (j < m && !check()) {
      ++j;
      add_edge(j);
    }
    if (check()) {
      ans += 1ll * (m - j + 1);
    }
    delete_edge(i);
  }
  cout << ans << "\n";

  return 0;
}
