#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <stack>
#include <set>
#include <queue>
#include <vector>

#define ll long long
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ss string
#define pb push_back

const int N = int(2e3) + 5, mod = int(1e9) + 7, INF = int(1e9);

using namespace std;

ll n, m, edge[N][N], t[N * 4];

vector < int > g[N];

bool used[N];

ll get(int v, int l, int r, int x, int y){
    if(x > r || l > y){
        return 0;
    }
    if(x <= l && r <= y){
        return t[v];
    }
    int tm = (l + r) / 2;
    return get(v + v, l, tm, x, y) + get(v + v + 1, tm + 1, r, x, y);
}

ll c(int a){
    ll res = 0;
    for(int i = 1; i + a - 1 <= m; i++){
        ll multi = get(1, 1, m, i, i + a - 1) - a;
        if(a - multi >= n - 1){
            res++;
        }
    }
    return res;
}

void dfs(int v){
    used[v] = 1;
    for(auto e : g[v]){
        if(!used[e]){
            dfs(e);
        }
    }
}

void update(int v, int l, int r, int pos){
    if(l == r){
        t[v] = 1;
        return;
    }
    int tm = (l + r) / 2;
    if(pos <= tm){
        update(v + v, l, tm, pos);
    }
    else{
        update(v + v + 1, tm + 1, r, pos);
    }
    t[v] = t[v + v] + t[v + v + 1];
}

int main(){
    speed;
    cin >> n >> m;
    int m1 = 0;
    for(int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        if(!edge[u][v]){
            edge[u][v] = edge[v][u] = 1;
            m1++;
            g[u].pb(v);
            g[v].pb(u);
        }
        update(1, 1, m, i);
    }
    dfs(1);
    for(int i = 1; i <= n; i++){
        if(!used[i]){
            cout << 0;
            return 0;
        }
    }
    ll ans = 0;
    for(int i = n - 1; i <= m; i++){
        ans += c(i);
    }
    cout << ans;
}
